/* fsm may 29 2005 s */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class fontchooser
	extends JDialog
{
	private JButton checkbutton, okbutton, cancelbutton, smallerbutton, biggerbutton;
	private JTextField fontnamefield;

	private Font origfont, myfont;

	public fontchooser(Component parent, Font origfont)
	{
		super((Frame)parent, true);

		this.origfont = origfont;
		myfont = origfont;

		make_window();
		register_events();

		setLocationRelativeTo(parent);
		setResizable(false);

		show();
	}

	public Font getFont()
	{
		return origfont;
	}

	private void make_window()
	{
		Container window;
		JPanel panel, options, buttons;

		/* create controls */
		fontnamefield = new JTextField(origfont.getName(), 20);
		checkbutton = new JButton("Check");
		smallerbutton = new JButton("-");
		biggerbutton = new JButton("+");

		fontnamefield.setFont(origfont);

		okbutton = new JButton("Ok");
		cancelbutton = new JButton("Cancel");

		/* create option part */
		options = new JPanel();
		options.setLayout(new FlowLayout());
		options.add(fontnamefield);
		options.add(checkbutton);
		options.add(smallerbutton);
		options.add(biggerbutton);

		/* create ok/cancel part */
		buttons = new JPanel();
		buttons.setLayout(new FlowLayout());
		buttons.add(okbutton);
		buttons.add(cancelbutton);

		/* add everything to the window */
		panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(options, BorderLayout.CENTER);
		panel.add(buttons, BorderLayout.SOUTH);

		window = getContentPane();
		window.add(panel);

		setTitle("font chooser");
		pack();

		/* make the text field the same height as a button */
		Dimension d1 = checkbutton.getSize();
		Dimension d2 = fontnamefield.getSize();
		d2.setSize(d2.getWidth(), d1.getHeight());
		fontnamefield.setPreferredSize(d2);

		pack();
	}

	private void register_events()
	{
		ActionEventHandler myactionlistener;

		/* window close event. seems to do the opposite of what we want
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		*/

		/* open/save button events */
		myactionlistener = new ActionEventHandler();
		checkbutton.addActionListener(myactionlistener);
		smallerbutton.addActionListener(myactionlistener);
		biggerbutton.addActionListener(myactionlistener);
		okbutton.addActionListener(myactionlistener);
		cancelbutton.addActionListener(myactionlistener);
	}

	private boolean is_font(String fontname)
	{
		Font f = new Font(fontname, Font.PLAIN, 12);
		return !f.getFontName().equals("Dialog.plain");
	}

	private class ActionEventHandler
		implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			Object obj = e.getSource();

			if (obj == checkbutton)
			{
				String fontname = fontnamefield.getText();
				if (is_font(fontname))
				{
					myfont = new Font(fontname, Font.PLAIN,
						fontnamefield.getFont().getSize());

					fontnamefield.setFont(myfont);
					fontnamefield.setText(myfont.getName());
				}
			}
			else if (obj == smallerbutton)
			{
				Font f = fontnamefield.getFont();
				myfont = new Font(f.getFontName(), Font.PLAIN, f.getSize() - 1);
				fontnamefield.setFont(myfont);
			}
			else if (obj == biggerbutton)
			{
				Font f = fontnamefield.getFont();
				myfont = new Font(f.getFontName(), Font.PLAIN, f.getSize() + 1);
				fontnamefield.setFont(myfont);
			}
			else if (obj == okbutton)
			{
				/* repeat what check does incase the user didn't use check */
				String fontname = fontnamefield.getText();
				if (is_font(fontname))
				{
					myfont = new Font(fontname, Font.PLAIN,
						fontnamefield.getFont().getSize());
				}

				/* do it this way so the window's x button doesn't change anything */
				origfont = myfont;

				hide();
			}
			else if (obj == cancelbutton)
			{
				hide();
			}
		}
	}
}

